/* ------------------------------------------------- */
/*                     FFHC.H                        */
/*               Headerfile zu FFHC.C                */
/*         (c) 1991 Axel Gener & DMV-Verlag         */
/* ------------------------------------------------- */
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>
#include "ffh.h"

#define NAME "FFHC"
#define PROG NAME ## "  FFast Help Compiler  Version" \
                  ## RELEASE \
                "  (c) 1991 Axel Gener & DMV-Verlag\n"
#define USAGE NAME ## " <Quelldatei> [Zieldatei] " \
                      "[{ /c| /h| /d}]"
#define S_EXT       ".FHS"
         /* Standarderweiterung der Hilfs-Quelldatei */
#define D_EXT       ".FHD"
         /* Standarderweiterung der Hilfs-Zieldatei  */
#define MAXLINE     255
                    /* maximal erlaubte Zeilenbreite */
#define KEYWORDSTR  "KEYWORD"
                    /* Kennstring fr Schlsselwort  */
#define HELPTEXTSTR "TEXT"
                    /* Kennstring fr Hilfstext      */

typedef struct tree
{
  char   *keyword;
  long   offs;
               /* Offset des zugehrigen Hilfstextes */
  long   textlen;
               /* Lnge des zugehrigen Hilfstextes  */
  struct tree *left, *right;
               /* Linker und rechter Nachfolger      */
} tree_t;

int main (int argc, char *argv[]);
tree_t *genleaf (char *name, long offs, tree_t *tree);
  /* sortiert die angeg. Daten nach name geordner in
     den Baum tree ein */
tree_t *search (char *name, tree_t *tree);
  /* sucht in tree nach name und liefert gefundenes */
  /* Blatt zurck */
FILE *skipnonalphas (FILE *fp);
  /* rckt den Filepointer bis zum nchsten  */
  /* Buchstaben vor. */
FILE *readfile (char *fname);
  /* liest die berg. Sourcedatei und liefert offenen
     Filepointer zurck */
void checkforkeywords (FILE *fp, char *fname,
                       char *type, char *res);
  /* sucht nach KEYWORD und TEXT */
void writefile (char *fname,tree_t *tree,FILE *infile);
  /* schreibt Zieldatei mit Hilfe der Daten von Baum
     tree und Datei infile */
void writetexts (tree_t *tree, FILE *infile,
                 FILE *outfile);
  /* schreibt die Texte aus infile mit Hilfe von
     tree in outfile */
void writetree (tree_t *tree, FILE *outfile);
  /* schreibt die Informationen im Baum tree
     nach outfile */
char *cpystr (char *s);
  /* belegt Speicher fr String s, kopiert ihn
     dorthin und liefert Adresse */
void showindex (char *fname);
  /* erstellt ein Schlsselwortverzeichnis von der
     ZIELdatei fname */
void checkparameters (char **argv);
  /* prft die Kommandozeilenparameter */
void error (const char *format, ...);
  /* gibt bergebene Daten aus und bricht das
     Programm ab */
/* ------------------------------------------------- */
/*              Ende von FFHC.H                      */

