(* ------------------------------------------------- *)
(*                  DATEIMOD.PAS                     *)
(*     ffnungscode fr Dateien an Reset bergeben   *)
(*        (C) 1990, 1992 Thomas Wolf & DMV-Verlag    *)
(* ------------------------------------------------- *)
PROGRAM DateiMod;

CONST
  FMReadOnly   =  0;   { Zugriff: Nur Lesen           }
  FMWriteOnly  =  1;   { Zugriff: Nur Schreiben       }
  FMReadWrite  =  2;   { Zugriff: Lesen und Schreiben }

VAR
  SaveFileMode : BYTE; { Sicherung des Dateimodus     }
  Datei        : FILE; { Testdatei                    }

  PROCEDURE SetNextAccess(AccessCode : BYTE);
  { Setzt die Variable FileMode auf den entsprechenden}
  { Zugriffscode                                      }
  BEGIN
    SaveFileMode := FileMode;
    IF (AccessCode >= 0) AND (AccessCode <= 2) THEN
      FileMode := AccessCode;
  END {SetNextAccess};

  PROCEDURE RestoreAccess;
  { Setzt die Variable FileMode auf den vorherigen    }
  { Zugriffscode zurck                               }
  BEGIN
    FileMode := SaveFileMode;
  END {RestoreAccess};

BEGIN
  WriteLn('FileMode - Test');
  Assign(datei, 'DUMMY.PAS');
            { irgendeine Datei mit Read-Only-Attribut }
  SetNextAccess(FMReadOnly);
  Reset(datei);  { Datei wird zum Nur-Lesen geffnet  }
  RestoreAccess;
  Close(datei);
END {DateiMod}.
(* ------------------------------------------------- *)
(*              Ende von DATEIMOD.PAS                *)
